---
title: Create an LLM Observability annotation queue
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > LLM Observability
---

# Create an LLM Observability annotation queue{% #create-an-llm-observability-annotation-queue %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                           |
| ----------------- | ---------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/annotation-queues |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/annotation-queues |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/llm-obs/v1/annotation-queues      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/llm-obs/v1/annotation-queues      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/annotation-queues  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/llm-obs/v1/annotation-queues     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/llm-obs/v1/annotation-queues |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/llm-obs/v1/annotation-queues |

### Overview

Create an annotation queue. The `name` and `project_id` fields are required. An optional `annotation_schema` can be provided to define the labels for the queue. Fields such as `created_by`, `owned_by`, `created_at`, `modified_by`, and `modified_at` are inferred by the backend.

### Request

#### Body Data (required)

Create annotation queue payload.

{% tab title="Model" %}

| Parent field      | Field                           | Type     | Description                                                                                                |
| ----------------- | ------------------------------- | -------- | ---------------------------------------------------------------------------------------------------------- |
|                   | data [*required*]          | object   | Data object for creating an LLM Observability annotation queue.                                            |
| data              | attributes [*required*]    | object   | Attributes for creating an LLM Observability annotation queue.                                             |
| attributes        | annotation_schema               | object   | Schema defining the labels for an annotation queue.                                                        |
| annotation_schema | label_schemas [*required*] | [object] | List of label schema definitions.                                                                          |
| label_schemas     | description                     | string   | Description of the label.                                                                                  |
| label_schemas     | has_assessment                  | boolean  | Whether this label includes an assessment field.                                                           |
| label_schemas     | has_reasoning                   | boolean  | Whether this label includes a reasoning field.                                                             |
| label_schemas     | id                              | string   | Unique identifier of the label schema. Assigned by the server if not provided.                             |
| label_schemas     | is_assessment                   | boolean  | Whether the boolean label represents an assessment. Requires `has_assessment` to be true.                  |
| label_schemas     | is_integer                      | boolean  | Whether score values must be integers. Applicable to score-type labels.                                    |
| label_schemas     | is_required                     | boolean  | Whether this label is required for an annotation.                                                          |
| label_schemas     | max                             | double   | Maximum value for score-type labels.                                                                       |
| label_schemas     | min                             | double   | Minimum value for score-type labels.                                                                       |
| label_schemas     | name [*required*]          | string   | Name of the label. Must match the pattern `^[a-zA-Z0-9_-]+$` and be unique within the queue.               |
| label_schemas     | type [*required*]          | enum     | Type of a label in an annotation queue label schema. Allowed enum values: `score,categorical,boolean,text` |
| label_schemas     | values                          | [string] | Allowed values for categorical-type labels. Must contain at least one non-empty, unique value.             |
| attributes        | description                     | string   | Description of the annotation queue.                                                                       |
| attributes        | name [*required*]          | string   | Name of the annotation queue.                                                                              |
| attributes        | project_id [*required*]    | string   | Identifier of the project this queue belongs to.                                                           |
| data              | type [*required*]          | enum     | Resource type of an LLM Observability annotation queue. Allowed enum values: `queues`                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "annotation_schema": {
        "label_schemas": [
          {
            "description": "Rating of the response quality.",
            "has_assessment": false,
            "has_reasoning": false,
            "id": "abc-123",
            "is_assessment": false,
            "is_integer": false,
            "is_required": true,
            "max": 5,
            "min": 0,
            "name": "quality",
            "type": "score",
            "values": [
              "good",
              "bad",
              "neutral"
            ]
          }
        ]
      },
      "description": "Queue for annotating customer support traces",
      "name": "My annotation queue",
      "project_id": "00000000-0000-0000-0000-000000000002"
    },
    "type": "queues"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing a single LLM Observability annotation queue.

| Parent field      | Field                           | Type      | Description                                                                                                |
| ----------------- | ------------------------------- | --------- | ---------------------------------------------------------------------------------------------------------- |
|                   | data [*required*]          | object    | Data object for an LLM Observability annotation queue.                                                     |
| data              | attributes [*required*]    | object    | Attributes of an LLM Observability annotation queue.                                                       |
| attributes        | annotation_schema               | object    | Schema defining the labels for an annotation queue.                                                        |
| annotation_schema | label_schemas [*required*] | [object]  | List of label schema definitions.                                                                          |
| label_schemas     | description                     | string    | Description of the label.                                                                                  |
| label_schemas     | has_assessment                  | boolean   | Whether this label includes an assessment field.                                                           |
| label_schemas     | has_reasoning                   | boolean   | Whether this label includes a reasoning field.                                                             |
| label_schemas     | id                              | string    | Unique identifier of the label schema. Assigned by the server if not provided.                             |
| label_schemas     | is_assessment                   | boolean   | Whether the boolean label represents an assessment. Requires `has_assessment` to be true.                  |
| label_schemas     | is_integer                      | boolean   | Whether score values must be integers. Applicable to score-type labels.                                    |
| label_schemas     | is_required                     | boolean   | Whether this label is required for an annotation.                                                          |
| label_schemas     | max                             | double    | Maximum value for score-type labels.                                                                       |
| label_schemas     | min                             | double    | Minimum value for score-type labels.                                                                       |
| label_schemas     | name [*required*]          | string    | Name of the label. Must match the pattern `^[a-zA-Z0-9_-]+$` and be unique within the queue.               |
| label_schemas     | type [*required*]          | enum      | Type of a label in an annotation queue label schema. Allowed enum values: `score,categorical,boolean,text` |
| label_schemas     | values                          | [string]  | Allowed values for categorical-type labels. Must contain at least one non-empty, unique value.             |
| attributes        | created_at [*required*]    | date-time | Timestamp when the queue was created.                                                                      |
| attributes        | created_by [*required*]    | string    | Identifier of the user who created the queue.                                                              |
| attributes        | description [*required*]   | string    | Description of the annotation queue.                                                                       |
| attributes        | modified_at [*required*]   | date-time | Timestamp when the queue was last modified.                                                                |
| attributes        | modified_by [*required*]   | string    | Identifier of the user who last modified the queue.                                                        |
| attributes        | name [*required*]          | string    | Name of the annotation queue.                                                                              |
| attributes        | owned_by [*required*]      | string    | Identifier of the user who owns the queue.                                                                 |
| attributes        | project_id [*required*]    | string    | Identifier of the project this queue belongs to.                                                           |
| data              | id [*required*]            | string    | Unique identifier of the annotation queue.                                                                 |
| data              | type [*required*]          | enum      | Resource type of an LLM Observability annotation queue. Allowed enum values: `queues`                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "annotation_schema": {
        "label_schemas": [
          {
            "description": "Rating of the response quality.",
            "has_assessment": false,
            "has_reasoning": false,
            "id": "abc-123",
            "is_assessment": false,
            "is_integer": false,
            "is_required": true,
            "max": 5,
            "min": 0,
            "name": "quality",
            "type": "score",
            "values": [
              "good",
              "bad",
              "neutral"
            ]
          }
        ]
      },
      "created_at": "2024-01-15T10:30:00Z",
      "created_by": "00000000-0000-0000-0000-000000000002",
      "description": "Queue for annotating customer support traces",
      "modified_at": "2024-01-15T10:30:00Z",
      "modified_by": "00000000-0000-0000-0000-000000000002",
      "name": "My annotation queue",
      "owned_by": "00000000-0000-0000-0000-000000000002",
      "project_id": "00000000-0000-0000-0000-000000000002"
    },
    "id": "00000000-0000-0000-0000-000000000001",
    "type": "queues"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/llm-obs/v1/annotation-queues" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "description": "Queue for annotating customer support traces",
      "name": "My annotation queue",
      "project_id": "00000000-0000-0000-0000-000000000002"
    },
    "type": "queues"
  }
}
EOF \## Create queue with annotation schema
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/llm-obs/v1/annotation-queues" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "annotation_schema": {
        "label_schemas": [
          {
            "is_required": true,
            "max": 5,
            "min": 0,
            "name": "quality",
            "type": "score"
          },
          {
            "name": "sentiment",
            "type": "categorical",
            "values": [
              "positive",
              "negative",
              "neutral"
            ]
          }
        ]
      },
      "description": "Queue for annotating customer support traces",
      "name": "My annotation queue",
      "project_id": "00000000-0000-0000-0000-000000000002"
    },
    "type": "queues"
  }
}
EOF 
                
##### 

```python
"""
Create an LLM Observability annotation queue returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.llm_observability_api import LLMObservabilityApi
from datadog_api_client.v2.model.llm_obs_annotation_queue_data_attributes_request import (
    LLMObsAnnotationQueueDataAttributesRequest,
)
from datadog_api_client.v2.model.llm_obs_annotation_queue_data_request import LLMObsAnnotationQueueDataRequest
from datadog_api_client.v2.model.llm_obs_annotation_queue_request import LLMObsAnnotationQueueRequest
from datadog_api_client.v2.model.llm_obs_annotation_queue_type import LLMObsAnnotationQueueType
from datadog_api_client.v2.model.llm_obs_annotation_schema import LLMObsAnnotationSchema
from datadog_api_client.v2.model.llm_obs_label_schema import LLMObsLabelSchema
from datadog_api_client.v2.model.llm_obs_label_schema_type import LLMObsLabelSchemaType

body = LLMObsAnnotationQueueRequest(
    data=LLMObsAnnotationQueueDataRequest(
        attributes=LLMObsAnnotationQueueDataAttributesRequest(
            annotation_schema=LLMObsAnnotationSchema(
                label_schemas=[
                    LLMObsLabelSchema(
                        description="Rating of the response quality.",
                        has_assessment=False,
                        has_reasoning=False,
                        id="abc-123",
                        is_assessment=False,
                        is_integer=False,
                        is_required=True,
                        max=5.0,
                        min=0.0,
                        name="quality",
                        type=LLMObsLabelSchemaType.SCORE,
                        values=[
                            "good",
                            "bad",
                            "neutral",
                        ],
                    ),
                ],
            ),
            description="Queue for annotating customer support traces",
            name="My annotation queue",
            project_id="00000000-0000-0000-0000-000000000002",
        ),
        type=LLMObsAnnotationQueueType.QUEUES,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_llm_obs_annotation_queue"] = True
with ApiClient(configuration) as api_client:
    api_instance = LLMObservabilityApi(api_client)
    response = api_instance.create_llm_obs_annotation_queue(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create an LLM Observability annotation queue returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_llm_obs_annotation_queue".to_sym] = true
end
api_instance = DatadogAPIClient::V2::LLMObservabilityAPI.new

body = DatadogAPIClient::V2::LLMObsAnnotationQueueRequest.new({
  data: DatadogAPIClient::V2::LLMObsAnnotationQueueDataRequest.new({
    attributes: DatadogAPIClient::V2::LLMObsAnnotationQueueDataAttributesRequest.new({
      annotation_schema: DatadogAPIClient::V2::LLMObsAnnotationSchema.new({
        label_schemas: [
          DatadogAPIClient::V2::LLMObsLabelSchema.new({
            description: "Rating of the response quality.",
            has_assessment: false,
            has_reasoning: false,
            id: "abc-123",
            is_assessment: false,
            is_integer: false,
            is_required: true,
            max: 5.0,
            min: 0.0,
            name: "quality",
            type: DatadogAPIClient::V2::LLMObsLabelSchemaType::SCORE,
            values: [
              "good",
              "bad",
              "neutral",
            ],
          }),
        ],
      }),
      description: "Queue for annotating customer support traces",
      name: "My annotation queue",
      project_id: "00000000-0000-0000-0000-000000000002",
    }),
    type: DatadogAPIClient::V2::LLMObsAnnotationQueueType::QUEUES,
  }),
})
p api_instance.create_llm_obs_annotation_queue(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create an LLM Observability annotation queue returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.LLMObsAnnotationQueueRequest{
		Data: datadogV2.LLMObsAnnotationQueueDataRequest{
			Attributes: datadogV2.LLMObsAnnotationQueueDataAttributesRequest{
				AnnotationSchema: &datadogV2.LLMObsAnnotationSchema{
					LabelSchemas: []datadogV2.LLMObsLabelSchema{
						{
							Description:   datadog.PtrString("Rating of the response quality."),
							HasAssessment: datadog.PtrBool(false),
							HasReasoning:  datadog.PtrBool(false),
							Id:            datadog.PtrString("abc-123"),
							IsAssessment:  datadog.PtrBool(false),
							IsInteger:     datadog.PtrBool(false),
							IsRequired:    datadog.PtrBool(true),
							Max:           datadog.PtrFloat64(5.0),
							Min:           datadog.PtrFloat64(0.0),
							Name:          "quality",
							Type:          datadogV2.LLMOBSLABELSCHEMATYPE_SCORE,
							Values: []string{
								"good",
								"bad",
								"neutral",
							},
						},
					},
				},
				Description: datadog.PtrString("Queue for annotating customer support traces"),
				Name:        "My annotation queue",
				ProjectId:   "00000000-0000-0000-0000-000000000002",
			},
			Type: datadogV2.LLMOBSANNOTATIONQUEUETYPE_QUEUES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateLLMObsAnnotationQueue", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewLLMObservabilityApi(apiClient)
	resp, r, err := api.CreateLLMObsAnnotationQueue(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `LLMObservabilityApi.CreateLLMObsAnnotationQueue`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `LLMObservabilityApi.CreateLLMObsAnnotationQueue`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create an LLM Observability annotation queue returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.LlmObservabilityApi;
import com.datadog.api.client.v2.model.LLMObsAnnotationQueueDataAttributesRequest;
import com.datadog.api.client.v2.model.LLMObsAnnotationQueueDataRequest;
import com.datadog.api.client.v2.model.LLMObsAnnotationQueueRequest;
import com.datadog.api.client.v2.model.LLMObsAnnotationQueueResponse;
import com.datadog.api.client.v2.model.LLMObsAnnotationQueueType;
import com.datadog.api.client.v2.model.LLMObsAnnotationSchema;
import com.datadog.api.client.v2.model.LLMObsLabelSchema;
import com.datadog.api.client.v2.model.LLMObsLabelSchemaType;
import java.util.Arrays;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createLLMObsAnnotationQueue", true);
    LlmObservabilityApi apiInstance = new LlmObservabilityApi(defaultClient);

    LLMObsAnnotationQueueRequest body =
        new LLMObsAnnotationQueueRequest()
            .data(
                new LLMObsAnnotationQueueDataRequest()
                    .attributes(
                        new LLMObsAnnotationQueueDataAttributesRequest()
                            .annotationSchema(
                                new LLMObsAnnotationSchema()
                                    .labelSchemas(
                                        Collections.singletonList(
                                            new LLMObsLabelSchema()
                                                .description("Rating of the response quality.")
                                                .hasAssessment(false)
                                                .hasReasoning(false)
                                                .id("abc-123")
                                                .isAssessment(false)
                                                .isInteger(false)
                                                .isRequired(true)
                                                .max(5.0)
                                                .name("quality")
                                                .type(LLMObsLabelSchemaType.SCORE)
                                                .values(Arrays.asList("good", "bad", "neutral")))))
                            .description("Queue for annotating customer support traces")
                            .name("My annotation queue")
                            .projectId("00000000-0000-0000-0000-000000000002"))
                    .type(LLMObsAnnotationQueueType.QUEUES));

    try {
      LLMObsAnnotationQueueResponse result = apiInstance.createLLMObsAnnotationQueue(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling LlmObservabilityApi#createLLMObsAnnotationQueue");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create an LLM Observability annotation queue returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_llm_observability::LLMObservabilityAPI;
use datadog_api_client::datadogV2::model::LLMObsAnnotationQueueDataAttributesRequest;
use datadog_api_client::datadogV2::model::LLMObsAnnotationQueueDataRequest;
use datadog_api_client::datadogV2::model::LLMObsAnnotationQueueRequest;
use datadog_api_client::datadogV2::model::LLMObsAnnotationQueueType;
use datadog_api_client::datadogV2::model::LLMObsAnnotationSchema;
use datadog_api_client::datadogV2::model::LLMObsLabelSchema;
use datadog_api_client::datadogV2::model::LLMObsLabelSchemaType;

#[tokio::main]
async fn main() {
    let body = LLMObsAnnotationQueueRequest::new(LLMObsAnnotationQueueDataRequest::new(
        LLMObsAnnotationQueueDataAttributesRequest::new(
            "My annotation queue".to_string(),
            "00000000-0000-0000-0000-000000000002".to_string(),
        )
        .annotation_schema(LLMObsAnnotationSchema::new(vec![LLMObsLabelSchema::new(
            "quality".to_string(),
            LLMObsLabelSchemaType::SCORE,
        )
        .description("Rating of the response quality.".to_string())
        .has_assessment(false)
        .has_reasoning(false)
        .id("abc-123".to_string())
        .is_assessment(false)
        .is_integer(false)
        .is_required(true)
        .max(5.0 as f64)
        .min(0.0 as f64)
        .values(vec![
            "good".to_string(),
            "bad".to_string(),
            "neutral".to_string(),
        ])]))
        .description("Queue for annotating customer support traces".to_string()),
        LLMObsAnnotationQueueType::QUEUES,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateLLMObsAnnotationQueue", true);
    let api = LLMObservabilityAPI::with_config(configuration);
    let resp = api.create_llm_obs_annotation_queue(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create an LLM Observability annotation queue returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createLLMObsAnnotationQueue"] = true;
const apiInstance = new v2.LLMObservabilityApi(configuration);

const params: v2.LLMObservabilityApiCreateLLMObsAnnotationQueueRequest = {
  body: {
    data: {
      attributes: {
        annotationSchema: {
          labelSchemas: [
            {
              description: "Rating of the response quality.",
              hasAssessment: false,
              hasReasoning: false,
              id: "abc-123",
              isAssessment: false,
              isInteger: false,
              isRequired: true,
              max: 5.0,
              min: 0.0,
              name: "quality",
              type: "score",
              values: ["good", "bad", "neutral"],
            },
          ],
        },
        description: "Queue for annotating customer support traces",
        name: "My annotation queue",
        projectId: "00000000-0000-0000-0000-000000000002",
      },
      type: "queues",
    },
  },
};

apiInstance
  .createLLMObsAnnotationQueue(params)
  .then((data: v2.LLMObsAnnotationQueueResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
